var ReadyState;
(function (ReadyState) {
    ReadyState[ReadyState["Unsent"] = 0] = "Unsent";
    ReadyState[ReadyState["Opened"] = 1] = "Opened";
    ReadyState[ReadyState["HeadersReceived"] = 2] = "HeadersReceived";
    ReadyState[ReadyState["Loading"] = 3] = "Loading";
    ReadyState[ReadyState["Ready"] = 4] = "Ready"; // 4	DONE	The operation is complete.
})(ReadyState || (ReadyState = {}));
var blinks;
(function (blinks) {
    var logd;
    function BlinkInit() {
        try {
            logd = document.getElementById("logdiv");
            var buttons = document.getElementById("buttons");
            //var btn = (text: string, color: string) => {
            //    let btn = document.createElement("button");
            //    btn.textContent = text;
            //    btn.style.backgroundColor = color;
            //    btn.style.fontSize = "14pt";
            //    btn.style.width = ".75in";
            //    btn.style.textAlign = "center";
            //    buttons.appendChild(btn);
            //    return btn;
            //};
            var btn = function (id, color) {
                var btn = document.getElementById(id);
                btn.classList.add('btn');
                btn.style.backgroundColor = color;
                return btn;
            };
            redInfo = new bulbInfo("red", btn("red", "crimson"), "crimson", "darkred");
            redInfo.btn.addEventListener("click", function () { return Blink({ Red: true }); });
            greenInfo = new bulbInfo("green", btn("green", "lime"), "lime", "DarkGreen");
            greenInfo.btn.addEventListener("click", function () { return Blink({ Green: true }); });
            var btnReload = btn("reload", "lightGrey");
            btnReload.style.color = "Red";
            btnReload.addEventListener("click", function () { return ws.send("reload!"); });
            spanCount = document.createElement("span");
            spanCount.style.fontSize = "14pt";
            buttons.appendChild(spanCount);
            spanPeriod = document.getElementById("OnPeriod");
            buttons.appendChild(document.createTextNode(" Interval: "));
            intervalInput = document.createElement("input");
            intervalInput.type = "range";
            intervalInput.min = ".5";
            intervalInput.max = "3";
            intervalInput.step = ".5";
            buttons.appendChild(intervalInput);
            intval = document.createElement("span");
            buttons.appendChild(intval);
            intervalInput.addEventListener("change", function () {
                intval.textContent = intervalInput.value;
                intval.style.backgroundColor = "pink";
                Blink({}); // Send new interval
            });
            intval.textContent = intervalInput.value;
            log("Initialized");
            wsTest();
        }
        catch (e) {
            alert("BlinkInit error " + e);
        }
    }
    blinks.BlinkInit = BlinkInit;
    var bulbInfo = (function () {
        function bulbInfo(name, btn, OnColor, OffColor) {
            this.name = name;
            this.btn = btn;
            this.OnColor = OnColor;
            this.OffColor = OffColor;
            this.On = document.getElementById(name + "On");
            this.Off = document.getElementById(name + "Off");
        }
        bulbInfo.prototype.set = function (onOff) {
            if (onOff == null)
                return;
            if (onOff) {
                this.Off.style.display = "none";
                this.On.style.display = "inline";
            }
            else {
                this.On.style.display = "none";
                this.Off.style.display = "inline";
            }
        };
        return bulbInfo;
    })();
    var redInfo;
    var greenInfo;
    var spanPeriod;
    var spanCount;
    var intervalInput;
    var intval;
    var lastDay;
    function timeStamp() {
        var ts = new Date().toString().split(' ');
        //   ['Thu',      0
        //    'Nov',      1
        //    '26',       2
        //    '2015',     3
        //    '22:11:38', 4
        //    'GMT-0500', 5
        //    '(Eastern', 'Standard',
        return ts[4]; // Just the time for now
    }
    function log(msg, clr, stamp) {
        var xp = function (txt, clr) {
            var pp = document.createElement("p");
            pp.textContent = txt;
            pp.classList.add('log');
            if (clr)
                pp.style.backgroundColor = clr;
            var fe = logd.firstElementChild;
            logd.insertBefore(pp, fe);
        };
        var dt = new Date();
        if (lastDay != dt.getDate()) {
            lastDay = dt.getDate();
            xp(dt.toString().split(" ").slice(1, 4).join(" "));
        }
        var lines = msg.split('\n');
        stamp = stamp || timeStamp();
        if (lines.length > 1) {
            for (var ln = lines.length - 1; ln >= 0; ln--) {
                var pfx = ln == (lines.length - 1) ? "└" : ln == 0 ? "┌" : "│";
                var st = "\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0";
                if (ln == 0)
                    st = stamp;
                log(pfx + " " + lines[ln], clr, st);
            }
            return;
        }
        xp(stamp + " " + msg, clr);
    }
    function Blink(bm) {
        //var bm2: BlinkMsgV2 = { Red: TurnOn, Green: !TurnOn };
        var bm2 = { Red: bm.Red, Green: bm.Green, Interval: parseFloat(intervalInput.value) };
        ws.send(bm2);
    }
    function BlinkHandler(result) {
        var resp = document.getElementById("response");
        resp.textContent = result;
        var bm = JSON.parse(result);
    }
    var sock = (function () {
        function sock() {
            var secure = window.location.protocol.indexOf("https") >= 0;
            var host = window.location.hostname;
            var port = parseInt(window.location.port) + 2; //  secure ? 8004 : 8003;
            var wsx = "ws" + (secure ? "s" : "");
            this.wrl = wsx + "://" + host + ":" + port;
            this.Init();
        }
        sock.prototype.Init = function () {
            try {
                log("Initializing Web Socket " + this.wrl);
                this.ws = new WebSocket(this.wrl);
                this.ws.addEventListener("message", this.GotMessage.bind(this));
                this.ws.addEventListener("close", this.Closed.bind(this));
                this.ws.addEventListener("error", this.GotError.bind(this));
                log("Constructed websocket");
            }
            catch (e) {
                log("Failed to Init " + e);
                setTimeout(this.Init.bind(this), 5000); // Try again in five seconds
            }
        };
        Object.defineProperty(sock.prototype, "isOpen", {
            get: function () { return (this.ws && this.ws.readyState == WebSocket.OPEN) == true; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(sock.prototype, "isConnecting", {
            get: function () { return (this.ws && this.ws.readyState == WebSocket.CONNECTING) == true; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(sock.prototype, "isClosed", {
            get: function () { return !this.ws || (this.ws.readyState == WebSocket.CLOSED || this.ws.readyState == WebSocket.CLOSING); },
            enumerable: true,
            configurable: true
        });
        sock.prototype.send = function (msg) {
            var txt = typeof msg == "string" ? msg : JSON.stringify(msg);
            try {
                if (!this.isOpen)
                    return; // For now just ignore until open
                log("WS Sending \"" + txt + "\"");
                this.ws.send(txt);
            }
            catch (e) {
            }
            return;
        };
        sock.prototype.GotMessage = function (me) {
            var msg = me.data;
            if (msg[0] == "{") {
                var obj = JSON.parse(msg);
                redInfo.set(obj.Red);
                greenInfo.set(obj.Green);
                document.getElementById("cname").textContent = obj.CName;
                if (obj.Count)
                    spanCount.textContent = " Count=" + obj.Count;
                if (obj.Interval) {
                    var interval = obj.Interval.toString();
                    if (intervalInput.value != interval) {
                        intval.textContent = interval;
                        intval.style.backgroundColor = "yellow";
                        intervalInput.value = interval;
                    }
                }
                spanPeriod.textContent = obj.OnPeriod.toString();
            }
            else {
                if (msg == "reload!")
                    window.location.reload(true);
                log("Got " + me.data);
            }
        };
        sock.prototype.Closed = function () {
            log("WS Closed\nWill retry periodically", "yellow");
            setTimeout(this.Init.bind(this), 1000); // Try again in one second
            this.ws = null;
        };
        sock.prototype.GotError = function (evt) {
            log("Web Socket error " + evt);
        };
        return sock;
    })();
    var ws;
    function wsTest() {
        try {
            ws = new sock();
        }
        catch (e) {
            alert("Web socket error " + e);
        }
    }
})(blinks || (blinks = {}));
window.addEventListener("load", function () { return blinks.BlinkInit(); });
//# sourceMappingURL=ClientApp.js.map